<template>
  <div class="user-card" v-show="idActualUser">
    <v-col cols="12">
      <v-card :color="color" class="py-1">
        <h1>{{ this.nickname }}</h1>
        <h1>{{ this.role }}</h1>
        <v-btn color="primary" @click="logOut()">logOut</v-btn>
      </v-card>
    </v-col>
  </div>
</template>

<script>
import API from '@/API.js'
export default {
  name: 'UserCard',
  components: {},
  props: {
    idActualUser: String,
    role: String
  },
  data() {
    return {
      nickname: '',
      color: '',
      user: null
    }
  },
  async mounted() {},
  watch: {
    role: {
      immediate: true,
      handler: function() {
        console.log('i am watching nada')
        if (this.role === 'admin') {
          this.color = 'blue'
        } else if (this.role === 'vendedor') {
          this.color = 'green'
        } else {
          this.color = 'white'
        }
      }
    },
    idActualUser: {
      immediate: true,
      handler: async function() {
        console.log('user card ')
        await this.loadUserDetails()
        this.nickname = this.user.nickname
      }
    }
  },

  methods: {
    logOut() {
      this.$emit('log-out-event')
    },
    async loadUserDetails() {
      let idSearchedUser = this.idActualUser
      this.user = await API.loadUserDetails(idSearchedUser)
    }
  }
}
</script>

<style scoped>
.user-card {
  font-size: 12px;
}
</style>
